---
title: MediaTrackSettings
slug: Web/API/MediaTrackSettings
tags:
  - API
  - Audio
  - Constraints
  - Dictionary
  - Interface
  - Media
  - Media Capture and Streams API
  - Media Streams API
  - MediaTrackSettings
  - NeedsExample
  - Reference
  - Video
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p>The <strong><code>MediaTrackSettings</code></strong> dictionary is used to return the current values configured for each of a {{domxref("MediaStreamTrack")}}'s settings. These values will adhere as closely as possible to any constraints previously described using a {{domxref("MediaTrackConstraints")}} object and set using {{domxref("MediaStreamTrack.applyConstraints", "applyConstraints()")}}, and will adhere to the default constraints for any properties whose constraints haven't been changed, or whose customized constraints couldn't be matched.</p>

<p>To learn more about how constraints and settings work, see <a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a>.</p>

<h2 id="Properties">Properties</h2>

<p>Some or all of the following will be included in the object, either because it's not supported by the browser or because it's not available due to context. For example, because {{Glossary("RTP")}} doesn't provide some of these values during negotiation of a WebRTC connection, a track associated with a {{domxref("RTCPeerConnection")}} will not include certain values, such as {{domxref("MediaTrackSettings.facingMode", "facingMode")}} or {{domxref("MediaTrackSettings.groupId", "groupId")}}.</p>

<h3 id="Properties_of_all_media_tracks">Properties of all media tracks</h3>

<dl>
 <dt>{{domxref("MediaTrackSettings.deviceId", "deviceId")}}</dt>
 <dd>A {{domxref("DOMString")}} indicating the current value of the <code>{{domxref("MediaTrackConstraints.deviceId", "deviceId")}}</code> property. The device ID is a origin-unique string identifying the source of the track; this is usually a {{Glossary("GUID")}}. This value is specific to the source of the track's data and is not usable for setting constraints; it can, however, be used for initially selecting media when calling {{domxref("MediaDevices.getUserMedia()")}}.</dd>
 <dt>{{domxref("MediaTrackSettings.groupId", "groupId")}}</dt>
 <dd>A {{domxref("DOMString")}} indicating the current value of the <code>{{domxref("MediaTrackConstraints.groupId", "groupId")}}</code> property. The group ID is a browsing session-unique string identifying the source group of the track. Two devices (as identified by the {{domxref("MediaTrackSettings.deviceId", "deviceId")}}) are considered part of the same group if they are from the same physical device. For instance, the audio input and output devices for the speaker and microphone built into a phone would share the same group ID, since they're part of the same physical device. The microphone on a headset would have a different ID, though. This value is specific to the source of the track's data and is not usable for setting constraints; it can, however, be used for initially selecting media when calling {{domxref("MediaDevices.getUserMedia()")}}.</dd>
</dl>

<h3 id="Properties_of_audio_tracks">Properties of audio tracks</h3>

<dl>
 <dt>{{domxref("MediaTrackSettings.autoGainControl", "autoGainControl")}}</dt>
 <dd>A Boolean which indicates the current value of the {{domxref("MediaTrackConstraints.autoGainControl", "autoGainControl")}} property, which is <code>true</code> if automatic gain control is enabled and is <code>false</code> otherwise.</dd>
 <dt>{{domxref("MediaTrackSettings.channelCount", "channelCount")}}</dt>
 <dd>A long integer value indicating the current value of the <code>{{domxref("MediaTrackConstraints.channelCount", "channelCount")}}</code> property, specifying the number of audio channels present on the track (therefore indicating how many audio samples exist in each audio frame). This is 1 for mono, 2 for stereo, and so forth.</dd>
 <dt>{{domxref("MediaTrackSettings.echoCancellation", "echoCancellation")}}</dt>
 <dd>A Boolean indicating the current value of the <code>{{domxref("MediaTrackConstraints.echoCancellation", "echoCancellation")}}</code> property, specifying <code>true</code> if echo cancellation is enabled, otherwise <code>false</code>.</dd>
 <dt>{{domxref("MediaTrackSettings.latency", "latency")}}</dt>
 <dd>A double-precision floating point value indicating the current value of the <code>{{domxref("MediaTrackConstraints.latency", "latency")}}</code> property, specifying the audio latency, in seconds. Latency is the amount of time which elapses between the start of processing the audio and the data being available to the next stop in the audio utilization process. This value is a target value; actual latency may vary to some extent for various reasons.</dd>
 <dt>{{domxref("MediaTrackSettings.noiseSuppression", "noiseSuppression")}}</dt>
 <dd>A Boolean which indicates the current value of the {{domxref("MediaTrackConstraints.noiseSuppression", "noiseSuppression")}} property, which is <code>true</code> if noise suppression is enabled and is <code>false</code> otherwise.</dd>
</dl>

<dl>
 <dt>{{domxref("MediaTrackSettings.sampleRate", "sampleRate")}}</dt>
 <dd>A long integer value indicating the current value of the <code>{{domxref("MediaTrackConstraints.sampleRate", "sampleRate")}}</code> property, specifying the sample rate in samples per second of the audio data. Standard CD-quality audio, for example, has a sample rate of 41,000 samples per second.</dd>
 <dt>{{domxref("MediaTrackSettings.sampleSize", "sampleSize")}}</dt>
 <dd>A long integer value indicating the current value of the <code>{{domxref("MediaTrackConstraints.sampleSize", "sampleSize")}}</code> property, specifying the linear size, in bits, of each audio sample. CD-quality audio, for example, is 16-bit, so this value would be 16 in that case.</dd>
 <dt>{{domxref("MediaTrackSettings.volume", "volume")}}</dt>
 <dd>A double-precision floating point value indicating the current value of the <code>{{domxref("MediaTrackConstraints.volume", "volume")}}</code> property, specifying the volume level of the track. This value will be between 0.0 (silent) to 1.0 (maximum supported volume).</dd>
</dl>

<h3 id="Properties_of_video_tracks">Properties of video tracks</h3>

<dl>
 <dt>{{domxref("MediaTrackSettings.aspectRatio", "aspectRatio")}}</dt>
 <dd>A double-precision floating point value indicating the current value of the <code>{{domxref("MediaTrackConstraints.aspectRatio", "aspectRatio")}}</code> property, specified precisely to 10 decimal places. This is the width of the image in pixels divided by its height in pixels. Common values include 1.3333333333 (for the classic television 4:3 "standard" aspect ratio, also used on tablets such as Apple's iPad), 1.7777777778 (for the 16:9 high-definition widescreen aspect ratio), and 1.6 (for the 16:10 aspect ratio common among widescreen computers and tablets).</dd>
 <dt>{{domxref("MediaTrackSettings.facingMode", "facingMode")}}</dt>
 <dd>A {{domxref("DOMString")}} indicating the current value of the <code>{{domxref("MediaTrackConstraints.facingMode", "facingMode")}}</code> property, specifying the direction the camera is facing. The value will be one of:
 <dl>
  <dt><code>"user"</code></dt>
  <dd>A camera facing the user (commonly known as a "selfie cam"), used for self-portraiture and video calling.</dd>
  <dt><code>"environment"</code></dt>
  <dd>A camera facing away from the user (when the user is looking at the screen). This is typically the highest quality camera on the device, used for general photography.</dd>
  <dt><code>"left"</code></dt>
  <dd>A camera facing toward the environment to the user's left.</dd>
  <dt><code>"right"</code></dt>
  <dd>A camera facing toward the environment to the user's right.</dd>
 </dl>
 </dd>
 <dt>{{domxref("MediaTrackSettings.frameRate", "frameRate")}}</dt>
 <dd>A double-precision floating point value indicating the current value of the <code>{{domxref("MediaTrackConstraints.frameRate", "frameRate")}}</code> property, specifying how many frames of video per second the track includes. If the value can't be determined for any reason, the value will match the vertical sync rate of the device the user agent is running on.</dd>
 <dt>{{domxref("MediaTrackSettings.height", "height")}}</dt>
 <dd>A long integer value indicating the current value of the <code>{{domxref("MediaTrackConstraints.height", "height")}}</code> property, specifying the height of the track's video data in pixels.</dd>
 <dt>{{domxref("MediaTrackSettings.width", "width")}}</dt>
 <dd>A long integer value indicating the current value of the {{domxref("MediaTrackSettings.width", "width")}} property, specifying the width of the track's video data in pixels.</dd>
 <dt>{{domxref("MediaTrackSettings.resizeMode", "resizeMode")}}</dt>
 <dd>A {{domxref("DOMString")}} indicating the current value of the <code>{{domxref("MediaTrackConstraints.resizeMode", "resizeMode")}}</code> property, specifying the mode used by the user agent to derive the resolution of the track. The value will be one of:
 <dl>
  <dt><code>"none"</code></dt>
  <dd>The track has the resolution offered by the camera, its driver or the OS.</dd>
  <dt><code>"crop-and-scale"</code></dt>
  <dd>The track's resolution might be the result of the user agent using cropping or downscaling from a higher camera resolution.</dd>
 </dl>
 </dd>
</dl>

<h3 id="Properties_of_shared_screen_tracks">Properties of shared screen tracks</h3>

<p>Tracks containing video shared from a user's screen (regardless of whether the screen data comes from the entire screen or a portion of a screen, like a window or tab) are generally treated like video tracks, with the exception that they also support the following added settings:</p>

<dl>
 <dt>{{domxref("MediaTrackSettings.cursor", "cursor")}}</dt>
 <dd>
 <p>A {{domxref("DOMString")}} which indicates whether or not the mouse cursor is being included in the generated stream and under what conditions. Possible values are:</p>

 <dl>
  <dt><code>always</code></dt>
  <dd>The mouse is always visible in the video content of the {domxref("MediaStream"), unless the mouse has moved outside the area of the content.</dd>
  <dt><code>motion</code></dt>
  <dd>The mouse cursor is always included in the video if it's moving, and for a short time after it stops moving.</dd>
  <dt><code>never</code></dt>
  <dd>The mouse cursor is never included in the shared video.</dd>
 </dl>
 </dd>
 <dt>{{domxref("MediaTrackSettings.displaySurface", "displaySurface")}}</dt>
 <dd>
 <p>A {{domxref("DOMString")}} which specifies the type of source the track contains; one of:</p>

 <dl>
  <dt><code>application</code></dt>
  <dd>The stream contains all of the windows of the application chosen by the user rendered into the one video track.</dd>
  <dt><code>browser</code></dt>
  <dd>The stream contains the contents of a single browser tab selected by the user.</dd>
  <dt><code>monitor</code></dt>
  <dd>The stream's video track contains the entire contents of one or more of the user's screens.</dd>
  <dt><code>window</code></dt>
  <dd>The stream contains a single window selected by the user for sharing.</dd>
 </dl>
 </dd>
 <dt>{{domxref("MediaTrackSettings.logicalSurface", "logicalSurface")}}</dt>
 <dd>A Boolean value which, if <code>true</code>, indicates that the video contained in the stream's video track contains a background rendering context, rather than a user-visible one. This is <code>false</code> if the video being captured is coming from a foreground (user-visible) source.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Screen Capture', '#dom-mediatracksettings', 'MediaTrackSettings')}}</td>
   <td>{{Spec2('Screen Capture')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaTrackSettings")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("MediaDevices.getUserMedia()")}}</li>
 <li>{{domxref("MediaDevices.getDisplayMedia()")}}</li>
 <li>{{domxref("MediaStreamTrack.getConstraints()")}}</li>
 <li>{{domxref("MediaStreamTrack.applyConstraints()")}}</li>
 <li>{{domxref("MediaStreamTrack.getSettings()")}}</li>
</ul>
